import pandas as pd
import datetime
import time
import csv
import numpy as np
#import matplolib.pyplot as plt

data_window = pd.read_csv(r"C:\Users\pilon\Desktop\projet/output1(window).csv",sep=',')
data_TV = pd.read_csv(r"C:\Users\pilon\Desktop\projet/output4(TV).csv",sep=',')
data_box_TV = pd.read_csv(r"C:\Users\pilon\Desktop\projet/output5(box_TV).csv",sep=',')
data_CO2= pd.read_csv(r"C:\Users\pilon\Desktop\projet/output2(CO2).csv",sep=',')
data_heater= pd.read_csv(r"C:\Users\pilon\Desktop\projet/output3(heater).csv",sep=',')
data_temperature= pd.read_csv(r"C:\Users\pilon\Desktop\projet/output6(température).csv",sep=',')
data_humidity= pd.read_csv(r"C:\Users\pilon\Desktop\projet/output7(humidité).csv",sep=',')
data_bruit= pd.read_csv(r"C:\Users\pilon\Desktop\projet/output8(bruit).csv",sep=',')#IOn extrait 8 fichiers CSV de la base de donnée EXPE-Smart que l'on va analyser

def stringdate_to_datetime(stringdatetime: str):#Cette fonction modifie le format de la date en enlevant le Z et en séparant la date de l'heure
    if "." in stringdatetime:
        stringdatetime=stringdatetime.split(".")[0]
    else:
        stringdatetime=stringdatetime.split("Z")[0]
    return datetime.datetime.fromtimestamp(time.mktime(time.strptime(stringdatetime, '%Y-%m-%dT%H:%M:%S')))


data_heater["datetime"]=data_heater["time"].apply(stringdate_to_datetime)#application d'un nouveau format à la date et l'heure pour chaque donnée
data_CO2["datetime"]=data_CO2["time"].apply(stringdate_to_datetime)
data_TV["datetime"]=data_TV["time"].apply(stringdate_to_datetime)
data_box_TV["datetime"]=data_box_TV["time"].apply(stringdate_to_datetime)
data_window["datetime"]=data_window["time"].apply(stringdate_to_datetime)
data_temperature["datetime"]=data_temperature["time"].apply(stringdate_to_datetime)
data_bruit["datetime"]=data_bruit["time"].apply(stringdate_to_datetime)
data_humidity["datetime"]=data_humidity["time"].apply(stringdate_to_datetime)

data_CO2["CO2"]=data_CO2["value"]#changement du nom "value" par ce que la valeur donne: le CO2 ici
data_TV["TV"]=data_TV["value"]
data_box_TV["box TV"]=data_box_TV["value"]
keep_CO2=['CO2']
data_window["window"]=data_window["value"]
keep_window=["window"]
data_heater["heater"]=data_heater["value"]
data_bruit["bruit"]=data_bruit["value"]
data_humidity["humidite"]=data_humidity["value"]
data_temperature["temperature"]=data_temperature["value"]


data_heater.set_index('datetime',inplace=True)
print("heater",data_heater.isnull().any())
data_heater.ffill()#☻on complete les trous vides avec cette fonction
data_heater=data_heater.resample('20T').sum()#Cette ligne permet de faire un échantillonage en prenant des valeurs toutes les 20 min
#On effectue cette opération pour les 8 tableaux que l'on a 

data_CO2.set_index('datetime',inplace=True)
print("CO2",data_CO2.isnull().any())
data_CO2.ffill()
data_CO2=data_CO2.resample('20T').sum()


data_bruit.set_index('datetime',inplace=True)
print("bruit",data_bruit.isnull().any())
data_bruit.ffill()
data_bruit=data_bruit.resample('20T').sum()

data_humidity.set_index('datetime',inplace=True)
print("humidite",data_humidity.isnull().any())
data_humidity.ffill()
data_humidity=data_humidity.resample('20T').sum()

data_temperature.set_index('datetime',inplace=True)
print("temperature",data_temperature.isnull().any())
data_temperature.ffill()
data_temperature=data_temperature.resample('20T').sum()

data_window.set_index('datetime',inplace=True)
print("window",data_window.isnull().any())
data_window.ffill()
data_window=data_window.resample('20T').sum()

data_TV.set_index('datetime',inplace=True)
print("TV",data_TV.isnull().any())
data_TV.ffill()
data_TV=data_TV.resample('20T').sum()

data_box_TV.set_index('datetime',inplace=True)
print("box TV",data_box_TV.isnull().any())
data_box_TV.ffill()
data_box_TV=data_box_TV.resample('20T').sum()

data_box_TV["label"]=data_box_TV["value"]#création d'une nouvelle colonne "label" étant l'occupancy que nous allons calculer à l'aide d'un algorithme d'intelligence artificielle

mergeDatasheet=[data_bruit, data_temperature, data_humidity, data_window,data_CO2,data_heater, data_TV, data_box_TV]#On additionne les tableaux pour en obtenir qu'un seul, regroupant toutes les données mesurées à la même heure

result=pd.concat(mergeDatasheet,axis=1,join='inner')
print(result)


#data_heater.set_index('datetime', inplace=True)
hours=[]

#data_datetimes=pd.to_datetime(newdata_CO2.iloc[:,0], format='%d%m%Y %H:%M')

#for dt in data_datetimes:
 #   hours.append(dt.hour)
    
#result['hour']=hours
#print(hours)

import time
import sys
import csv


"""################################

from sklearn import metrics
import datetime

import time

import csv

import numpy as np

from math import *

from sklearn import tree

from sklearn.model_selection import train_test_split

import matplotlib.pyplot as plt

#for price calculation part

from itertools import combinations







# Divide the data into training and testing


x_train, x_test, y_train, y_test = train_test_split(result[["TV","box TV","humidite","bruit","CO2"]],result[["label"]],test_size=.1,random_state=0)



# On definit 

def importance (x_train, y_train) :

    classifier = tree.DecisionTreeClassifier(random_state=0, criterion='entropy', max_depth=None) 

    classifier.fit(x_train, y_train) 

    important = classifier.feature_importances_

    return important



most_important= importance (x_train, y_train)

print("most_important",most_important)





# implementation of decision tree



def decision_tree(x_test,y_test,x_train,y_train) :



    classifier=tree.DecisionTreeClassifier(max_depth=3)

    classifier.fit(x_train,y_train)

    prediction=classifier.predict(x_test)

    accuracy = classifier.score(x_test, y_test)

    print("accuracy", accuracy)

    features_importance= classifier.feature_importances_

    #print(" feature_ importance",features_importance)

    indices=np.argsort(features_importance)

    # plt.title('feature importance')

    # plt.barh(range(len(indices)), features_importance[indices], color = 'b', align = 'center')

    # plt.yticks(range(len(indices)), [x_train.columns.values[i] for i in indices])

    # plt.xlabel('Relative importance')

    with open ("tree.dot","w") as file :

        f=tree.export_graphviz(classifier,out_file=file)

    return(prediction, accuracy)





    



#change the depth



(prediction, accu) = decision_tree(x_test,y_test,x_train,y_train)

print("the predicted occupancy is: \n",prediction)





def accurary_dif_depths(size):

    depth = [] #abcisse

    accuracy = []  #ordonnée

     #show the accuracy from 1 to size-1

    for i in range(1, size):

        classifier=tree.DecisionTreeClassifier(max_depth=i)

        classifier.fit(x_train,y_train)

        depth.append(i)

        accuracy.append(classifier.score(x_test, y_test))  #accuracy for dpth = 1

        #print( i, classifier.score(x_test, y_test)) #to test

    #show the accuracy for 'None' last

    classifier=tree.DecisionTreeClassifier(max_depth=None)

    classifier.fit(x_train,y_train)

    depth.append(i)

    accuracy.append(classifier.score(x_test, y_test))#accuracy correspond à la précision

    plt.plot(depth, accuracy)

    return (depth, accuracy)



(depth,accuracy) = accurary_dif_depths(3)
n=0
for i in result['label']:
    if i < 0.5:
        result.loc[n, 'label'] = 0
    else:
        result.loc[n, 'label'] = 1
    n = n + 1
N=len(result)
graph=np.zeros(N)
for i in range N :
    if occupancy=1 and window=1 and CO2<1000 and heater=1 :
        graph[i]=1

plot(result,graph)
xlabel("Time")
ylabel("Wasted energy")"""

